﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TechnoAP.usbmca.common
{
    /// <summary>
    /// Summary for command
    /// </summary>
    public class command
    {
        /// <summary>
        /// Generation of command telegram
        /// </summary>
        static public byte[] createTelegram(string command, int channel, uint value)
        {
            byte[] abResult = new byte[8];

            string wcommand = createCommand(command, channel);

            if (wcommand != string.Empty)
            {
                byte[] abCommand = System.Text.Encoding.ASCII.GetBytes(wcommand);

                int nWork = System.Net.IPAddress.HostToNetworkOrder((int)(value));
                byte[] abValue = BitConverter.GetBytes(nWork);

                Buffer.BlockCopy(abCommand, 0, abResult, 0, 4);
                Buffer.BlockCopy(abValue, 0, abResult, 4, 4);
            }
            else
            {
                abResult = null;
            }

            return abResult;

        }

        /// <summary>
        /// Extraction from command telegram
        /// </summary>
        /// <param name="abAnswer">command telegram</param>
        /// <param name="value">parameter value</param>
        /// <returns>command text</returns>
        static public string restoreCommand(byte[] abAnswer, ref uint value)
        {
            string strResult = string.Empty;

            byte[] abWork = new byte[5];
            Array.Clear(abWork, 0, abWork.Length);
            Array.Copy(abAnswer, abWork, 4);

            strResult = System.Text.Encoding.ASCII.GetString(abWork);

            int wvalue = BitConverter.ToInt32(abAnswer, 4);
            value = (uint)(System.Net.IPAddress.NetworkToHostOrder(wvalue));

            return strResult;

        }

        /// <summary>
        /// Generate command string
        /// </summary>
        static public string createCommand(string command, int channel)
        {
            string strResult = string.Empty;

            switch ((constant.CH_TYPE)(channel))
            {
                case constant.CH_TYPE.Common:   // Common commands
                    strResult = command;
                    break;
                case constant.CH_TYPE.CH1:      // CH1
                    strResult = command + "W";

                    if ((constant.Command.isChCommand(command, constant.Command.IFG) == true) ||
                       (constant.Command.isChCommand(command, constant.Command.IOF) == true))
                    {
                        strResult = command + "0";
                    }

                    break;
                case constant.CH_TYPE.CH2:      // CH2
                case constant.CH_TYPE.CH3:      // CH3
                case constant.CH_TYPE.CH4:      // CH4
                    strResult = string.Format("{0}{1:d}", command, (channel - 1));
                    break;
                default:
                    break;
            }

            return strResult;

        }
    }
}
